/**********************************************************************

	--- Qt Architect generated file ---

	File: c2freq.cpp
	Last generated: Tue Jul 25 20:51:32 2000

 *********************************************************************/

#include <unistd.h>

#include "c2freq.h"

#include "wintvscreen.h"

#include <qtooltip.h> 

#include <kapp.h>
#include <klocale.h>


#ifdef myDEBUG
#define frDEBUG
#endif

#define FUCKUP_TUNER

#define Inherited c2freqData

c2freq::c2freq
(
        rcfile *_rc,
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name ),rc(_rc)
{
  localchan= new channel();
  localchan->name=0;
  localchan->channelId=0;

  minfreq = 0;
  maxfreq = 0x7fff;
  scanstate = ScanSetup;
  scanknownonly = false;
  sigquality = (int)(65535.0*((double)SIGQUALITY/100.0));

  winTVScreenWidget::v4lxifP()->capTunerRange(&minfreq,&maxfreq);

#ifdef frDEBUG
  debug("c2freq: init, minf %lu, maxf %lu",minfreq,maxfreq);
#endif

  QToolTip::add(c2ffine,i18n("fine tune"));
}

c2freq::~c2freq()
{
  delete localchan;
}

void c2freq::setData(channel *schan)
{
  localchan->frequency=schan->frequency;
  localfreq= localchan->frequency;
  winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency);
  c2ffreq->display(QString().setNum(localchan->frequency/16.0,'f',4));
  usleep(SCAN_DELAY);
  c2fqual->display((int)(winTVScreenWidget::v4lxifP()->getTunerSignal()/65535*100));

  c2ffine->setValue(0);

  c2fscup->setEnabled(true);
  c2fscdn->setEnabled(true);
  c2fstop->setEnabled(false);
}
void c2freq::getData(channel *fchan)
{
  fchan->frequency=localchan->frequency;
}
void c2freq::c2fscupSLOT() // scan up
{
  if ( scanstate == ScanSetup ) {
    scanstate = ScanUp;

    scanfval = 5;
    slost1 = (winTVScreenWidget::v4lxifP()->getTunerSignal() < sigquality);
    sfound = false;
    slost2 = false;
    ffound = localchan->frequency;
    flost = localchan->frequency;
    localfreq = localchan->frequency;

    c2ffine->setValue(0);

    c2fscup->setEnabled(false);
    c2fscdn->setEnabled(false);
    c2ffine->setEnabled(false);
    c2fstop->setEnabled(true);
  } 
  if ( scanstate == ScanUp ) {
    localchan->frequency+=scanfval;
    winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency);
    if ( localchan->frequency > maxfreq ) localchan->frequency = minfreq;
    QTimer::singleShot( SCAN_DELAY, this, SLOT(autoScanSLOT()) );
    //qApp->processEvents( SCAN_DELAY );
  }
}
void c2freq::c2fscdnSLOT() // scan down
{
  if ( scanstate ==  ScanSetup ) {
    scanstate = ScanDown;

    scanfval = 5;
    slost1 = (winTVScreenWidget::v4lxifP()->getTunerSignal() < sigquality);
    sfound = false;
    slost2 = false;
    ffound = localchan->frequency;
    flost = localchan->frequency;
    localfreq = localchan->frequency;

    c2ffine->setValue(0);

    c2fscup->setEnabled(false);
    c2fscdn->setEnabled(false);
    c2ffine->setEnabled(false);
    c2fstop->setEnabled(true);

  }
  if ( scanstate == ScanDown ) {
    localchan->frequency-=scanfval;
    if ( localchan->frequency < minfreq ) localchan->frequency = maxfreq;
    winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency);
    QTimer::singleShot( SCAN_DELAY, this, SLOT(autoScanSLOT()) );
    //qApp->processEvents( SCAN_DELAY );
  }
}
void c2freq::c2fallcSLOT(bool on) 
{
  scanknownonly = on;
}
void c2freq::c2ffineSLOT(int val)
{
  localchan->frequency= localfreq + val;
#ifdef frDEBUG
  debug("c2freq: fine tune %d delta %d",localchan->frequency,val);
#endif

  bool muted = winTVScreenWidget::v4lxifP()->getAudioMute();
  if ( ! muted ) {
    winTVScreenWidget::v4lxifP()->setAudioMute(true);
    usleep(500);
  }

#ifdef FUCKUP_TUNER
  winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency-16);
  usleep(SCAN_DELAY);
#endif
  winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency);
  c2ffreq->display(QString().setNum(localchan->frequency/16.0,'f',4));

  usleep(SCAN_DELAY*100);

  if ( ! muted ) {
    winTVScreenWidget::v4lxifP()->setAudioMute(false);
  }

  c2fqual->display((int)(winTVScreenWidget::v4lxifP()->getTunerSignal()/65535*100));
}
void c2freq::newRangeSLOT(int fmin, int fmax, int smax)
{
#ifdef frDEBUG
  debug("c2freq: newRange %d %d %d",fmin,fmax,smax);
#endif
//    minfreq=fmin;
//    maxfreq=fmax;
  c2ffine->setRange( -smax, smax );
}
void c2freq::frequencyChangedSLOT(int nfreq)
{
#ifdef frDEBUG
  debug("c2freq: frequencyChanged %d",nfreq);
#endif
  localchan->frequency= nfreq;
  localfreq= nfreq;

  c2ffine->setValue(0);

  c2ffreq->display(QString().setNum(localchan->frequency/16.0,'f',4));
  c2fqual->display((int)(winTVScreenWidget::v4lxifP()->getTunerSignal()/65535*100));
}
void c2freq::autoScanSLOT()
{
  int quality = winTVScreenWidget::v4lxifP()->getTunerSignal();

#ifdef frDEBUG
  debug("c2freq: autoScan %d, %d, %d, %d, %d, %d",
	quality,sigquality,slost1,sfound,slost2,localchan->frequency);
#endif

  c2ffreq->display(QString().setNum(localchan->frequency/16.0,'f',4));
  c2fqual->display(quality/65535*100);

  if ( !slost2 ) { 

    if ( !slost1 ) {
      slost1 = quality < sigquality;
      if ( slost1 ) scanfval = 2; // was 2
    } else if ( !sfound ) {
      sfound = quality > sigquality;
      if ( sfound ) { 
	ffound = localchan->frequency;
	smaxsig = quality;
	fmaxsig = localchan->frequency;
	scanfval = 1;
      }
    } else if ( !slost2 ) {
      if ( smaxsig < quality ) {
	smaxsig = quality;
	fmaxsig = localchan->frequency;
      }
      slost2 = quality < sigquality;
      if ( slost2 ) {
	flost = localchan->frequency - ((scanstate == ScanUp) ? 1 : -1);
      }
    }

    switch (scanstate) {
    case ScanDown: 
      c2fscdnSLOT();
      break;
    case ScanUp: 
      c2fscupSLOT();
      break;
    default:
      break;
    }
  } else {
    //scanstate = ScanAbort;

#ifdef frDEBUG
    debug("c2freq: autoScan %d, found at %d, lost at %d, set %d, delta %d",
	  quality,ffound,flost,(flost+ffound)/2,ffound-flost);
#endif

    if  ( slost1 && slost2 && sfound ) {
      if ( fmaxsig == ffound && smaxsig == 0xffff ) { // fake signal quality
	localchan->frequency = ((scanstate == ScanUp) ? 1 : -1) + (flost + ffound) / 2;
#ifdef frDEBUG
    debug("c2freq: fake sigquality mode, set %d",localchan->frequency);
#endif
      } else {
	localchan->frequency = fmaxsig;
      }
#ifdef FUCKUP_TUNER
      winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency - 16);
      usleep(SCAN_DELAY);
#endif
      winTVScreenWidget::v4lxifP()->setFreq(localchan->frequency);
    }

    localfreq = localchan->frequency;

    int loop = 0;
    while ( loop < 10 && winTVScreenWidget::v4lxifP()->getTunerSignal() < fmaxsig - 100 ) {
      loop++;
      usleep(SCAN_DELAY);
    }

    c2ffreq->display(QString().setNum(localchan->frequency/16.0,'f',4));
    c2fqual->display((int)(winTVScreenWidget::v4lxifP()->getTunerSignal()/65535*100));

    parentWidget()->setEnabled(true);
    c2fscup->setEnabled(true);
    c2fscdn->setEnabled(true);
    c2ffine->setEnabled(true);
    c2fstop->setEnabled(false);

    scanstate = ScanSetup;
  }
}
void c2freq::c2fstopSLOT()
{
#ifdef frDEBUG
  debug("c2freq: scan abort");
#endif
  scanstate=ScanSetup;

  parentWidget()->setEnabled(true);
  c2fscup->setEnabled(true);
  c2fscdn->setEnabled(true);
  c2ffine->setEnabled(true);
  c2fstop->setEnabled(false);
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
#include "c2freq.moc"
