/**********************************************************************

	--- Qt Architect generated file ---

	File: c2prog.cpp
	Last generated: Tue Jul 25 20:51:16 2000

 *********************************************************************/

#include <unistd.h>

#include <wintv.h>

#include "c2prog.h"

#include "countries.h"
#include "wintvscreen.h"

#include <qtooltip.h> 

#include <kapp.h>
#include <klocale.h>


#ifdef myDEBUG
#define csDEBUG
#endif


#define Inherited c2progData

c2prog::c2prog
(
        rcfile *_rc,
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name ),rc(_rc)
{
  int i,aktive;
#ifdef csDEBUG
  debug("c2prog init");
#endif

  ch=(char *)malloc(255);

  localchan= new channel();
  localchan->name=0;
  localchan->channelId=0;

#if 1
#ifdef csDEBUG
  debug("c2prog country is %s, %d",chanlist_names[rc->country_id].str,rc->country_id);
#endif
  currentCountry.change(rc->country_id);
  rc->country_name=QString(chanlist_names[rc->country_id].str);
#endif

  int ff;
  ff=currentCountry.firstchan(ch);
  c2pchannels->insertItem(ch);
  while (ff != currentCountry.nextchan(ch) )
    c2pchannels->insertItem(ch);

  // fill in known conuties
  for (i=0; i <= KNOWN_COUNTRIES; i++) {
    c2pcountries->insertItem(chanlist_names[i].str,i);
  }
  c2pcountries->setCurrentItem(0);

  // fill in supported norms
  int tflags= winTVScreenWidget::v4lxifP()->getTunerFlags();
  int tmode= winTVScreenWidget::v4lxifP()->getChannelNorm();

#ifdef EXTRA_BTTV_NORMS
#ifdef csDEBUG
  debug("c2prog EXTRA_BTTV_NORMS enabled");
#endif
  for (i = 0; norms_bttv[i].str != NULL; i++) { // XXXX
    //if (tflags & (1<<i)) {
    c2pnorm->insertItem(norms_bttv[i].str,i);
    if (tmode == i) aktive=i;
    //}
  }
#else
  for (i = 0; norms[i].str != NULL; i++)  // XXXX
    if (tflags & (1<<i)) {
      c2pnorm->insertItem(norms[i].str,i);
      if (tmode == i) aktive=i;
    }
#endif
  c2pnorm->setCurrentItem(aktive);

  // fill in known input sources
  for (i = 0; i < winTVScreenWidget::v4lxifP()->capCapChannelC(); i++) {
    c2psource->insertItem(winTVScreenWidget::v4lxifP()->capChannelName(i),i);
  }

  QToolTip::add(c2pcountries,i18n("receiving region"));
  QToolTip::add(c2pdown,i18n("channel down"));
  QToolTip::add(c2pup,i18n("channel up"));
  QToolTip::add(c2psource,i18n("input device of TV card"));
  QToolTip::add(c2pnorm,i18n("input norm"));
  QToolTip::add(c2pchannels,i18n("select channel"));
}


c2prog::~c2prog()
{
  free(ch);
  if ( localchan != NULL )
    delete localchan;
}

void c2prog::getData( channel * fchan )
{
  fchan->frequency=localchan->frequency;
  fchan->country=localchan->country;
  if (fchan->name) {
    delete [] fchan->name;
    fchan->name=0;
  }
  if ( localchan->name ) {
    fchan->name=new char[strlen(localchan->name)+1];
    strcpy(fchan->name,localchan->name);
  }
  fchan->norm=localchan->norm;
  fchan->input=localchan->input;
}

void c2prog::setData( channel * inchan )
{
  if ( inchan == NULL ) return;

#ifdef csDEBUG
  debug("c2prog setData, inchan->country = %d, rinchan->country_id = %d, cid = %d, item = %d",
	inchan->country,rc->country_id,currentCountry.cid(),c2pcountries->currentItem());
#endif

  localchan->frequency=inchan->frequency;
  localchan->country=inchan->country;
  if ( localchan->country == -1 ) {
    c2pcountries->setCurrentItem(rc->country_id);
    c2pcountriesSLOT(rc->country_id);
  } else if ( localchan->country != currentCountry.cid() ) {
    c2pcountries->setCurrentItem(localchan->country);
    c2pcountriesSLOT(localchan->country);
  } else if ( localchan->country != c2pcountries->currentItem() ) {
    c2pcountries->setCurrentItem(localchan->country);
  }

#ifdef csDEBUG
  debug("c2prog %s",inchan->name);
#endif
  c2pname->setText(inchan->name);
#ifdef csDEBUG
  debug("c2prog %s",inchan->name);
#endif
  if (localchan->name) {
    delete localchan->name;
    localchan->name=0;
  }
  if ( inchan->name ) {
    localchan->name=new char[strlen(inchan->name)+1];
    strcpy(localchan->name,inchan->name);
  }

  c2pnorm->setCurrentItem(inchan->norm);
  localchan->norm=inchan->norm;
  c2psource->setCurrentItem(inchan->input);
  localchan->input=inchan->input;
    
  currentCountry.setchan(currentCountry.freqtochan(localchan->frequency));
  c2pchannels->setCurrentItem(currentCountry.activeindex());

#ifdef csDEBUG
  debug("c2prog setData set cid %s",inchan->channelId);
#endif

  if (localchan->channelId) {
    delete localchan->channelId;
    localchan->channelId=0;
  }
  if ( inchan->channelId && strcmp(inchan->channelId,"??") ) {
    localchan->channelId=new char[strlen(inchan->channelId)+1];
    strcpy(localchan->channelId,inchan->channelId);
  } else {
    localchan->channelId=new char[strlen(ch)+1];
    strcpy(localchan->channelId,ch);
  }
#ifdef csDEBUG
  debug("c2prog setData done set cid %s",localchan->channelId);
#endif

  bool hastuner=winTVScreenWidget::v4lxifP()->capChannelTuner(winTVScreenWidget::v4lxifP()->getChannelActive());
  c2pdown->setEnabled(hastuner);
  c2pup->setEnabled(hastuner);
  c2pcountries->setEnabled(hastuner);
  c2pchannels->setEnabled(hastuner);
  //c2pnorm->setEnabled(v4lxifP->capChannelNorm(v4lxifP->getChannelActive()));

  emit newRangeSIGNAL(currentCountry.fmin(),currentCountry.fmax(),currentCountry.smax());
  emit frequencyChangedSIGNAL(localchan->frequency);
#ifdef csDEBUG
  debug("c2prog setData done");
#endif
}

void c2prog::c2pcountriesSLOT(int id)
{
#ifdef csDEBUG
  debug("c2prog new country: %s %d",chanlist_names[id].str,id);
#endif
  currentCountry.change(id);
  c2pchannels->clear();

  int ff=currentCountry.firstchan(ch);
  c2pchannels->insertItem(ch);
  while ( ff != currentCountry.nextchan(ch) )
    c2pchannels->insertItem(ch);

  rc->country_id=id;
  rc->country_name=QString(chanlist_names[id].str);
  localchan->country= id;
  if (currentCountry.setchan(currentCountry.freqtochan(localchan->frequency))) {
    localchan->frequency=currentCountry.activechan(ch);
  } else {
    localchan->frequency=currentCountry.firstchan(ch);
  }

  if (localchan->channelId) delete localchan->channelId;
  localchan->channelId=new char[strlen(ch)+1];
  strcpy(localchan->channelId,ch);

  emit frequencyChangedSIGNAL(localchan->frequency);
  emit newRangeSIGNAL(currentCountry.fmin(),currentCountry.fmax(),currentCountry.smax());
}

//#if QT_VERSION < 200
void c2prog::c2pnameSLOT(const char* name)
{
  if (localchan->name) delete localchan->name;
  localchan->name=new char[strlen(name)+1];
  strcpy(localchan->name,name);
}
void c2prog::c2pchannelsSLOT(const char * name)
{
#ifdef csDEBUG
  debug("c2prog: c2pchannelsSLOT: set %s",name);   
#endif
  if ( !currentCountry.setchan(name) ) 
    warning("c2prog: channel <%s> not found ?!?",name);
    
  localchan->frequency=currentCountry.cftofreq((char*)name,0);
  currentCountry.freqtochan(localchan->frequency);
  winTVScreenWidget::v4lxifP()->setFreq( localchan->frequency );
  emit frequencyChangedSIGNAL(localchan->frequency);

  if (localchan->channelId) delete localchan->channelId;
  localchan->channelId=new char[strlen(name)+1];
  strcpy(localchan->channelId,name);

#ifdef csDEBUG
  debug("c2prog: new channel done");   
#endif
}
//#else
void c2prog::c2pnameSLOT(const QString& name)
{
#ifdef csDEBUG
  debug("c2prog c2pnameSLOT %s",(const char *)name);
#endif
  if (localchan->name) delete localchan->name;
  localchan->name=new char[name.length()+1];
  strcpy(localchan->name,(const char *)name);
}
void c2prog::c2pchannelsSLOT(const QString& name)
{
#ifdef csDEBUG
  debug("c2prog: c2pchannelsSLOT Q: set %s",(const char *)name);   
#endif
  if ( !currentCountry.setchan((const char *)name) ) 
    warning("c2prog: channel <%s> not found ?!?",(const char *)name);
    
  localchan->frequency=currentCountry.cftofreq((char *)(const char*)name,0);
  currentCountry.freqtochan(localchan->frequency);
  winTVScreenWidget::v4lxifP()->setFreq( localchan->frequency );
  emit frequencyChangedSIGNAL(localchan->frequency);

  if (localchan->channelId) delete localchan->channelId;
  localchan->channelId=new char[name.length()+1];
  strcpy(localchan->channelId,(const char *)name);

#ifdef csDEBUG
  debug("c2prog: new channel done");   
#endif
}
//#endif

void c2prog::c2pdownSLOT()
{
  localchan->frequency=currentCountry.nextchan(ch);

  if (localchan->channelId) delete localchan->channelId;
  localchan->channelId=new char[strlen(ch)+1];
  strcpy(localchan->channelId,ch);

  c2pchannels->setCurrentItem(currentCountry.activeindex());

  bool muted = winTVScreenWidget::v4lxifP()->getAudioMute();
  if ( ! muted ) {
    winTVScreenWidget::v4lxifP()->setAudioMute(true);
    usleep(250);
  }

  winTVScreenWidget::v4lxifP()->setFreq( localchan->frequency );

  if ( ! muted ) {
    usleep(500);
    winTVScreenWidget::v4lxifP()->setAudioMute(false);
  }

  emit frequencyChangedSIGNAL(localchan->frequency);
#ifdef csDEBUG
  debug("c2prog new channel: %s %d % .3f",ch,localchan->frequency,localchan->frequency/16.0);
#endif
}
void c2prog::c2pupSLOT()
{
  localchan->frequency=currentCountry.prevchan(ch);

  //localchan->channelId=ch;
  if (localchan->channelId) delete localchan->channelId;
  localchan->channelId=new char[strlen(ch)+1];
  strcpy(localchan->channelId,ch);

  c2pchannels->setCurrentItem(currentCountry.activeindex());

  bool muted = winTVScreenWidget::v4lxifP()->getAudioMute();
  if ( ! muted ) {
    winTVScreenWidget::v4lxifP()->setAudioMute(true);
    usleep(250);
  }

  winTVScreenWidget::v4lxifP()->setFreq( localchan->frequency );

  if ( ! muted ) {
    usleep(500);
    winTVScreenWidget::v4lxifP()->setAudioMute(false);
  }

  emit frequencyChangedSIGNAL(localchan->frequency);
#ifdef csDEBUG
  debug("c2prog new channel: %s %d, % .3f",ch,localchan->frequency,localchan->frequency/16.0);
#endif
}
void c2prog::c2pnormSLOT(int id)
{
  localchan->norm=id;
  winTVScreenWidget::v4lxifP()->setChannelNorm( id );
#ifdef csDEBUG
  debug("c2prog new norm: %d",id);   
#endif
}
void c2prog::c2sourceSLOT(int id)
{
  localchan->input=id;
  winTVScreenWidget::v4lxifP()->setChannel( id );

#if 0
  c2pnorm->setEnabled(winTVScreenWidget::v4lxifP()->capChannelNorm(id));
  if (winTVScreenWidget::v4lxifP()->capChannelNorm(id)) {
    c2pnorm->setCurrentItem(localchan->norm);
  }
#endif

  bool chHasTuner= winTVScreenWidget::v4lxifP()->capChannelTuner(id);
  c2pdown->setEnabled(chHasTuner);
  c2pup->setEnabled(chHasTuner);
  c2pcountries->setEnabled(chHasTuner);
  c2pchannels->setEnabled(chHasTuner);

  if ( !chHasTuner ) {
    if (localchan->channelId) delete localchan->channelId;
    localchan->channelId=new char[6];
    strcpy(localchan->channelId,"(cam)");

    //localchan->channelId=new char[strlen(v4lxifP->capChannelName(id))+1];
    //strcpy(localchan->channelId,v4lxifP->capChannelName(id));

    // hu, well, do we want this??
    //c2pname->setText(winTVScreenWidget::v4lxifP()->capChannelName(id));
  }
#ifdef csDEBUG
  debug("c2prog new input source: %d, has tuner: %s",id,chHasTuner?"yes":"no");   
#endif
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
#include "c2prog.moc"
