/* 
    kwintv 

    Copyright (C) 1998 Moritz Wenk (wenk@mathematik.uni-kl.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef winTVscan_included
#define winTVscan_included

#include "rcfile.h"
#include "countries.h"
#include "channel.h"
#include "v4lxif.h"

#include <kwizard.h> 

#include <wizNorm.h>
#include <wizRegion.h>
#include <wizScan.h>
#include <wizFinish.h>

class winTVScanWizard : public KWizard
{
    Q_OBJECT

public:
  enum WizState { WizCanceled, WizOk };

  winTVScanWizard(QWidget *parent = 0, const char *name = 0 );
  ~winTVScanWizard();

  QList<channel> * getChannelListP() { return &channellist; }

  WizState getWizState() { return wizstate; }
  void reset();

signals:
  void endWizardSIGNAL();

protected slots:
  void selectedSLOT(int);
  void selectedSLOT(const QString &);
  void okClickedSLOT();
  void cancelClickedSLOT();
  void scanFinishedSLOT();

private:
#if QT_VERSION < 200
  KWizardPage wizPstart;
  KWizardPage wizPnorm;
  KWizardPage wizPregion;
  KWizardPage wizPscan;
  KWizardPage wizPfinish;
#endif

  wizFinish * wizstart;
  wizNorm * wiznorm;
  wizRegion * wizregion;
  wizScan * wizscan;
  wizFinish * wizfinish;

  QButton * okbutton;

  WizState wizstate;
  bool scanwasdone;
#if QT_VERSION < 200
  int lastpage;
#else
  QWidget * lastpage;
#endif

  QList<channel> channellist;
};
#endif // winTVscan_included










