/* 
    xWinTV using Bt848 frame grabber driver

    Copyright (C) 1998 Moritz Wenk (wenk@mathematik.uni-kl.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef wintvvclip_included
#define wintvvclip_included

#include <wintv.h>

#include <qtooltip.h>
#include <ktmainwindow.h>
#include <kstatusbar.h>

#include <cvclip.h> 

#include <vtab.h>
#include <wintvstreamview.h>
#include <sframerate.h>
#include <soptions.h>

#include <rcfile.h>
#include <videoclip.h>

/* ------------------------------------------------------------------------------*/
/* ------------------------------------------------------------------------------*/

class winTVVClipWidget : public KTMainWindow
{
  Q_OBJECT

public:
  winTVVClipWidget( rcfile * _rc = NULL, QWidget * parent = NULL, const char * name = NULL );
  ~winTVVClipWidget();


public slots:
  void toggleVClipSLOT();

protected slots:
  void optionsSLOT();
  void saveAsSLOT();
  void closeSLOT();

  void applyTabSLOT();
  void defaultTabSLOT();
  void cancelTabSLOT();

signals:
  

private:
  rcfile *rc;

  wintvstreamview * streamview;

  vtab *tab;
  sframerate * sframeratetab;
  soptions * stimertab;
  soptions * soptionstab;

  bool clip;
  QString dummy;

  QPixmap  pm;
};

#endif





