/**********************************************************************

	--- Qt Architect generated file ---

	File: wintvstreamview.cpp
	Last generated: Wed Oct 4 14:38:17 2000

 *********************************************************************/

#include "wintvscreen.h"
#include "wintvstreamview.h"

// video clip stuff
#include <avivideoclip.h>
#include <rawvideoclip.h>
#include <ppmvideoclip.h>

#include <qtooltip.h>
#include <kiconloader.h>
#include <klocale.h>

#define Inherited wintvstreamviewData

#ifdef myDEBUG
#define vsDEBUG
#endif

struct FORMATS {
  int id;
  char *name;
  struct GRAB_FORMAT *format;
};

static struct FORMATS formats[] = {
  { VIDEOCLIP_AVI, "avi video+audio", &avi_formats[0] },
  { VIDEOCLIP_PPM, "file streaming", &file_formats[0] },
  { VIDEOCLIP_RAW, "raw video data", &raw_formats[0] },
  { -1 ,NULL, NULL }
};

struct vcids {
  int id;
  int val;
  char * name;
};

struct vcids vc_rates[] = {
  { 0, 11025, "11025" },
  { 1, 22050, "22050" },
  { 2, 44100, "44100" },
  { -1 , 3, NULL }
};

struct vcids vc_bits[] = {
  { 0,  8, " 8" },
  { 1, 16, "16" },
  { -1, 2, NULL }
};

struct vcids vc_channels[] = {
  { 0, 1, "mono" },
  { 1, 2, "stereo"}, 
  {-1, 2, NULL }
};

#if QT_VERSION < 200
extern QPixmap BarIcon(const char* name);
#endif

wintvstreamview::wintvstreamview
(
        rcfile * _rc,
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
  int i,p;
  int px,py;
  QString dstr;

  rc = _rc;
  prefix=(char *)malloc(1024);

  v4lx = winTVScreenWidget::v4lxifP();
  video = NULL;

  stream_status = Stop; 

  /////////////////////////////////////////////////////////////////////////////
  // init movie params from rc 
  moviepar.capture_video=rc->vc_videocapture;
  moviepar.capture_audio=rc->vc_audiocapture;
  moviepar.video_format=rc->vc_format;
  moviepar.width=rc->vc_width;
  moviepar.height=rc->vc_height;
  moviepar.fps=rc->vc_fps;
  if (rc->vc_audiocapture) moviepar.channels=rc->vc_channels; 
  else moviepar.channels=0;
  moviepar.audio_format=rc->vc_audioformat;
  moviepar.bits=rc->vc_bits;
  moviepar.rate=rc->vc_rate;
  strcpy(moviepar.filename,(const char *)rc->vc_tempName);
  moviepar.video_clip=rc->vc_video_clip;
  moviepar.frames=rc->vc_frames;
  moviepar.unlimited_frames=rc->vc_frames_unlimited;

  /////////////////////////////////////////////////////////////////////////////
  QString name(moviepar.filename);
  name.append(VIDNAME);
  if ( rc->vc_video_clip ) name.append("xxxxx");
  name.append(formats[rc->vc_video_clip].format[rc->vc_format].ext);

  /////////////////////////////////////////////////////////////////////////////
  i=0;
  while ( formats[i].name ) {
    cbFormat->insertItem( formats[i].name );
    i++;
  }
  cbFormat->setCurrentItem(rc->vc_video_clip);
  setTypeList(rc->vc_video_clip);

  ins_rx=true;
  ins_ry=true;

  i=0;px=-1;py=-1;
  while ( cv_dimensions[i].id != -1 ) {
    cbXRes->insertItem(dstr.setNum(cv_dimensions[i].w));
    cbYRes->insertItem(dstr.setNum(cv_dimensions[i].h));
    if ( rc->vc_width == cv_dimensions[i].w ) px = i;
    if ( rc->vc_height == cv_dimensions[i].h ) py = i;
    i++;
  }

#ifdef vsDEBUG
  debug("streamer: x %d, y %d, %d, %d",rc->vc_width,rc->vc_height,px,py);
#endif

  if ( px == -1 ) {
    cbXRes->insertItem(dstr.setNum(rc->vc_width));
    cbXRes->setCurrentItem(cbXRes->count()-1);
  } else {
    cbXRes->setCurrentItem(px);
  }
  if ( py == -1 ) {
    cbYRes->insertItem(dstr.setNum(rc->vc_height));
    cbYRes->setCurrentItem(cbYRes->count()-1);
  } else {
    cbYRes->setCurrentItem(py);
  }

  ins_rx=false;
  ins_ry=false;

  /////////////////////////////////////////////////////////////////////////////
  i=0;p=0;
  cbSampleRate->clear();
  while ( vc_rates[i].name ) {
    cbSampleRate->insertItem(vc_rates[i].name);
    if ( vc_rates[i].val == rc->vc_rate ) p = i;
    i++;
  }
  cbSampleRate->setCurrentItem(p);

  i=0;p=0;
  cbAudioBits->clear();
  while ( vc_bits[i].name ) {
    cbAudioBits->insertItem(vc_bits[i].name);
    if ( vc_bits[i].val == rc->vc_bits ) p = i;
    i++;
  }
  cbAudioBits->setCurrentItem(p);

  i=0;p=0;
  cbAudioMode->clear();
  while ( vc_channels[i].name ) {
    cbAudioMode->insertItem(vc_channels[i].name);
    if ( vc_channels[i].val == rc->vc_channels ) p = i;
    i++;
  }
  cbAudioMode->setCurrentItem(p);

  /////////////////////////////////////////////////////////////////////////////
  cbKeepAR->setChecked(rc->vc_keepar);
  cbCaptureAudio->setChecked(rc->vc_audiocapture);
  cbCaptureVideo->setChecked(rc->vc_videocapture);

  bStreamRecord->setPixmap(BarIcon("record.png"));
  bStreamPause->setPixmap(BarIcon("player_pause.png"));
  bStreamStop->setPixmap(BarIcon("player_stop.png"));

  bStreamPause->setEnabled(false);
  bStreamStop->setEnabled(false);

  bStartTimer->setEnabled(false);

  lFrames->setText("0");
  lFPS->setText("0.0");
  lFLOST->setText("0");
  lStatus->setText(i18n("stopped"));

  QToolTip::add(bStreamRecord,i18n("record a video stream"));
  QToolTip::add(bStreamPause,i18n("pause recording"));
  QToolTip::add(bStreamStop,i18n("stop recording"));
}

wintvstreamview::~wintvstreamview()
{
  free(prefix);
}

void wintvstreamview::cbXResSLOT(const char * res)
{
#if QT_VERSION < 200
  if ( ins_rx ) return;

  bool isnumber;
  int val=QString(res).toInt(&isnumber);
  if ( isnumber ) {
    if ( rc->vc_keepar ) {
      int i;
      for ( i = 0; i < cbYRes->count(); i++ )
	if ( (QString(cbYRes->text(i)).toInt() & ~2) == (val*3/4) & ~2 ) {
	  ins_ry=true;
	  cbYRes->setCurrentItem(i);
	  moviepar.height = rc->vc_height = QString(cbYRes->text(i)).toInt();
	  ins_ry=false;
	  break;
	}
#ifdef vsDEBUG
      debug("streamer: cbXRes keep ar %d %d %d %d",val,(val*3/4)&~2,i,cbYRes->count());
#endif
      if ( i == cbYRes->count() ) {
	QString dstr;
	ins_ry=true;
	cbYRes->insertItem(dstr.setNum((val*3/4)&~2));
	cbYRes->setCurrentItem(cbYRes->count()-1);
	moviepar.height = rc->vc_height = (val*3/4)&~2;
	ins_ry=false;
#ifdef vsDEBUG
      debug("streamer: cbXRes ins to cbYRes %d",(val*3/4)&~2);
#endif
      }      
    }
    moviepar.width = val;
    rc->vc_width = val;
  }
#ifdef vsDEBUG
  debug("streamer: cbXRes %d",val);
#endif
#endif // #if QT_VERSION < 200
}
void wintvstreamview::cbYResSLOT(const char * res)
{
#if QT_VERSION < 200
  if ( ins_ry ) return;

  bool isnumber;
  int val=QString(res).toInt(&isnumber);
  if ( isnumber ) {
    if ( rc->vc_keepar ) {
     int i;
      for ( i = 0; i < cbXRes->count(); i++ )
	if ( (QString(cbXRes->text(i)).toInt() & ~2) == (val*4/3) & ~2 ) {
	  ins_rx=true;
	  cbXRes->setCurrentItem(i);
	  moviepar.width = rc->vc_width = QString(cbXRes->text(i)).toInt();
	  ins_rx=false;
	  break;
	}
#ifdef vsDEBUG
      debug("streamer: cbYRes keep ar %d %d %d %d",val,(val*4/3) & ~2,i,cbXRes->count());
#endif
      if ( i == cbXRes->count() ) {
	QString dstr;
	ins_rx=true;
	cbXRes->insertItem(dstr.setNum((val*4/3) & ~2));
	cbXRes->setCurrentItem(cbXRes->count()-1);
	moviepar.width = rc->vc_width = (val*4/3) & ~2;
	ins_rx=false;
#ifdef vsDEBUG
      debug("streamer: cbYRes ins to cbXRes %d",(val*4/3) & ~2);
#endif
      }       
    }
    moviepar.height = val;
    rc->vc_height = val;
  }
#ifdef vsDEBUG
  debug("streamer: cbYRes %d",val);
#endif
#endif // #if QT_VERSION < 200
}
void wintvstreamview::cbXResSLOT(const QString& res)
{
#if QT_VERSION >= 200
  if ( ins_rx ) return;

  bool isnumber;
  int val=res.toInt(&isnumber);

  if ( isnumber ) {
    if ( rc->vc_keepar ) {
      int i;
      for ( i = 0; i < cbYRes->count(); i++ )
	if ( (cbYRes->text(i).toInt() & ~2) == ((val*3/4) & ~2) ) {
	  ins_ry=true;
	  cbYRes->setCurrentItem(i);
	  moviepar.height = rc->vc_height = cbYRes->text(i).toInt();
	  ins_ry=false;
	  break;
	}
#ifdef vsDEBUG
      debug("streamer: cbXRes keep ar %d %d %d %d",val,(val*3/4)&~2,i,cbYRes->count());
#endif
      if ( i == cbYRes->count() ) {
	QString dstr;
	ins_ry=true;
	cbYRes->insertItem(dstr.setNum((val*3/4)&~2));
	cbYRes->setCurrentItem(cbYRes->count()-1);
	moviepar.height = rc->vc_height = (val*3/4)&~2;
	ins_ry=false;
#ifdef vsDEBUG
      debug("streamer: cbXRes ins to cbYRes %d",(val*3/4)&~2);
#endif
      }
    }
    moviepar.width = val;
    rc->vc_width = val;
  }
#ifdef vsDEBUG
  debug("streamer: cbXRes %d x %d, %d x %d",rc->vc_width,rc->vc_height,moviepar.width,moviepar.height);
#endif
#endif // #if QT_VERSION >= 200
}
void wintvstreamview::cbYResSLOT(const QString& res)
{
#if QT_VERSION >= 200
  if ( ins_ry ) return;

  bool isnumber;
  int val=res.toInt(&isnumber);
  if ( isnumber ) {
    if ( rc->vc_keepar ) {
     int i;
      for ( i = 0; i < cbXRes->count(); i++ )
	if ( (cbXRes->text(i).toInt() & ~2) == ((val*4/3) & ~2) ) {
	  ins_rx=true;
	  cbXRes->setCurrentItem(i);
	  moviepar.width = rc->vc_width = cbXRes->text(i).toInt();
	  ins_rx=false;
	  break;
	}
#ifdef vsDEBUG
      debug("streamer: cbYRes keep ar %d %d %d %d",val,(val*4/3) & ~2,i,cbXRes->count());
#endif
      if ( i == cbXRes->count() ) {
	QString dstr;
	ins_rx=true;
	cbXRes->insertItem(dstr.setNum((val*4/3) & ~2));
	cbXRes->setCurrentItem(cbXRes->count()-1);
	moviepar.width = rc->vc_width = (val*4/3) & ~2;
	ins_rx=false;
#ifdef vsDEBUG
      debug("streamer: cbYRes ins to cbXRes %d",(val*4/3) & ~2);
#endif
      } 
    }
    moviepar.height = val;
    rc->vc_height = val;
  }
#ifdef vsDEBUG
  debug("streamer: cbYRes %d x %d, %d x %d",rc->vc_width,rc->vc_height,moviepar.width,moviepar.height);
#endif
#endif // #if QT_VERSION >= 200
}
void wintvstreamview::cbKeepARSLOT(bool on)
{
  rc->vc_keepar = on;
}
void wintvstreamview::cbCaptureAudioSLOT(bool on)
{
  rc->vc_audiocapture = on;
  moviepar.capture_audio = on;

  cbSampleRate->setEnabled(on);
  cbAudioBits->setEnabled(on);
  cbAudioMode->setEnabled(on);
}
void wintvstreamview::cbSampleRateSLOT(int rate)
{
  moviepar.rate = vc_rates[rate].val;
  rc->vc_rate = vc_rates[rate].val;
}
void wintvstreamview::cbAudioBitsSLOT(int bits)
{
  moviepar.bits = vc_bits[bits].val;
  rc->vc_bits = vc_bits[bits].val;
}
void wintvstreamview::cbAudioModeSLOT(int mode)
{
  moviepar.audio_format = vc_channels[mode].val;
  rc->vc_audioformat = vc_channels[mode].val;
}
void wintvstreamview::bCloseSLOT()
{
  bStreamStopSLOT();
  emit closeRequestSIGNAL();
}
void wintvstreamview::cbCaptureVideoSLOT(bool on)
{
  rc->vc_videocapture = on;
  moviepar.capture_video = on;

  cbXRes->setEnabled(on);
  cbYRes->setEnabled(on);
  cbKeepAR->setEnabled(on);
}
void wintvstreamview::cbFormatSLOT(int format)
{
  rc->vc_video_clip = format;
  moviepar.video_clip = format;
  setTypeList(format);

  bool can_audio = (formats[format].format[rc->vc_format].can_sound == 1);
  cbCaptureAudio->setEnabled(can_audio);
  cbSampleRate->setEnabled(can_audio && rc->vc_audiocapture);
  cbAudioBits->setEnabled(can_audio && rc->vc_audiocapture);
  cbAudioMode->setEnabled(can_audio && rc->vc_audiocapture);

  bool can_video = (formats[format].format[rc->vc_format].can_video == 1);
  cbCaptureVideo->setEnabled(can_video && can_audio);
  cbXRes->setEnabled(can_video && rc->vc_videocapture);
  cbYRes->setEnabled(can_video && rc->vc_videocapture);
  cbKeepAR->setEnabled(can_video && rc->vc_videocapture);

  cbCaptureAudio->setChecked((can_audio && rc->vc_videocapture) || !can_video);
  cbCaptureVideo->setChecked((can_video && rc->vc_videocapture) || !can_audio);
}
void wintvstreamview::cbTypeSLOT(int type)
{
  rc->vc_format = type;
  moviepar.video_format = type;
}
void wintvstreamview::setTypeList(int clip)
{
  int i=0;
  cbType->clear();
  while ( formats[clip].format[i].name ) {
    cbType->insertItem( formats[clip].format[i].name );
    //debug("streamer: p %d, i %d, %s",p,i,formats[p].format[i].name);
    i++;
  }
  
  if ( rc->vc_format < formats[clip].format[i].bt848 ) 
    cbType->setCurrentItem(rc->vc_format);
  else {
    rc->vc_format=formats[clip].format[i].bt848-1;
    cbType->setCurrentItem(rc->vc_format);
  }
}
void wintvstreamview::bStartTimerSLOT()
{
  lStatus->setText(i18n("timer"));
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

void wintvstreamview::bStreamRecordSLOT()
{
#ifdef vsDEBUG
  debug("streamer: bStreamRecordSLOT");
#endif

  if ( stream_status == Stop ) {
    int palette;

    lostframes = 0;
    frames = 0;

    switch (moviepar.video_clip) {
    case VIDEOCLIP_AVI: // avi
      video= new aviVideoClip();
      palette= avi_formats[moviepar.video_format].bt848;
      break;
    case VIDEOCLIP_PPM: // ppm
      video= new ppmVideoClip();
      palette= file_formats[moviepar.video_format].bt848;
      break;
    case VIDEOCLIP_RAW: // raw
      video= new rawVideoClip();
      palette= raw_formats[moviepar.video_format].bt848;
      break;
    default:
      fatal("streamer: unsupported video format %d",moviepar.video_clip);
    }

#ifdef vsDEBUG
    debug("streamer: opening video-file %s",moviepar.filename);
    debug("streamer: video: x %d, y %d, fps %d",moviepar.width,moviepar.height,moviepar.fps);
    debug("streamer: audio: [%s], ch %d, b %d, r %d",(moviepar.capture_audio?"on":"off"),
	  moviepar.channels,moviepar.bits,moviepar.rate);
#endif

    // AUDIO CAPTURE
    // disable audio capture since it does not work till now.
    moviepar.capture_audio = false;

    QString fname(moviepar.filename);
    fname.append(VIDNAME);

    video->open( (char *)(const char *)fname, &moviepar );
    v4lx->grabSetParams( true, &(moviepar.width), &(moviepar.height), palette );

    lFrames->setText("0");
    lFPS->setText("0.0");
    lFLOST->setText("0");

    lStatus->setText(i18n("recording"));
  } 

  stream_status = Recording;

  bStreamRecord->setEnabled(false);
  bStreamPause->setEnabled(true);
  bStreamStop->setEnabled(true);

  streamerLoop();
}
void wintvstreamview::bStreamPauseSLOT()
{
  return;

  switch ( stream_status ) {
  case Recording:
    bStreamRecord->setEnabled(true);
    stream_status = Pause;
    lStatus->setText(i18n("paused"));
    break;
  case Pause:
    bStreamRecord->setEnabled(false);
    stream_status = Recording;
    streamerLoop();
    break;
  default:
    return;
  }
}
void wintvstreamview::bStreamStopSLOT()
{
#ifdef vsDEBUG
  debug("streamer: bStreamStopSLOT");
#endif

  if ( stream_status == Stop ) 
    return;

  stream_status = StopRequest;

  lStatus->setText(i18n("stopped"));

  bStreamRecord->setEnabled(true);
  bStreamPause->setEnabled(false);
  bStreamStop->setEnabled(false);
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

void wintvstreamview::streamerLoop()
{

  int fps=video->parameter()->fps;
  int lfps=fps-1;

  qApp->processEvents( 1000 ); 

  videoTime.start();

  while ( stream_status == Recording && (moviepar.unlimited_frames || frames <= moviepar.frames) ) {
    
    qApp->processEvents( 10 ); 

    elapsed=videoTime.elapsed();
    if ( (((frames * 1000.0) / (double)elapsed) <= fps) ) {

      video->writeframe( v4lx->grabCapture( false ) );

      //if (!(frames % 5)) lFrames->setText(dummy.setNum(frames));
      lFrames->setText(dummy.setNum(frames));
      frames++;

      elapsed=videoTime.elapsed();
#if 0
      if ( ((frames * 1000.0) /(double)elapsed) < lfps ) {
	// lost a frame!
	lostframes++;
	lFLOST->setText(dummy.setNum(lostframes));
	//frames++;
	elapsed=videoTime.elapsed();
	frames= elapsed*fps;
      }
#endif
    } 
  }

#ifdef vsDEBUG
  debug("streamer: stopping");
#endif

  if ( frames >= moviepar.frames && stream_status == Recording )
    stream_status = StopRequest;

  elapsed=videoTime.elapsed();
  frames=video->nframes();
  lFrames->setText(dummy.setNum(frames));
  lFLOST->setText(dummy.setNum(lostframes));
  lFPS->setText(dummy.setNum((double)(frames*1000.0)/(double)elapsed,'f',3));

  if ( stream_status == StopRequest ) 
    streamerStop();

#ifdef vsDEBUG
  debug("streamer: wrote %ld frames, %ld msec. , %3.1f fps",frames,elapsed,(double)frames/elapsed*1000);
#endif
}

void wintvstreamview::streamerStop()
{
#ifdef vsDEBUG
  debug("streamer: streamerStop");
#endif

  if ( stream_status == Stop ) 
    return;

  if ( video != NULL ) {

#ifdef vsDEBUG
  debug("streamer: streamerStop stopping");
#endif

    video->close();

    switch (moviepar.video_clip) {
    case VIDEOCLIP_AVI: // avi
      delete (aviVideoClip*)video;
      break;
    case VIDEOCLIP_PPM: // ppm
      delete (ppmVideoClip*)video;
    break;
    case VIDEOCLIP_RAW: // raw
      delete (rawVideoClip*)video;
      break;
    default:
      fatal("streamer: unsupported video format %d",moviepar.video_clip);
    }
    video = NULL;
  }

  stream_status = Stop;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
#include "wintvstreamview.moc"
