/**********************************************************************

	--- Qt Architect generated file ---

	File: wizScan.cpp
	Last generated: Sat Aug 26 20:12:46 2000

 *********************************************************************/

#include <unistd.h>

#include "wizScan.h"
#include "wintvscreen.h"

#include <klocale.h>

#ifdef myDEBUG
#define wzDEBUG
#endif

#define MIN_COUNT 10

#define Inherited wizScanData

wizScan::wizScan
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
  wizLLCFound->setText("0");
  wizPBProgress->reset();

  minfreq = 0;
  maxfreq = 0x7fff;
  scanstate = ScanSetup;
  sigquality = (int)(65535.0*((double)SIGQUALITY/100.0));

  winTVScreenWidget::v4lxifP()->capTunerRange(&minfreq,&maxfreq);

  if ( minfreq == 0x8e ) minfreq = 640; // 40MHz
  if ( maxfreq == 0x7fff ) maxfreq /= 2;

  frange = maxfreq - minfreq;

  wizLCDFreq->display(QString().setNum(minfreq/16.0,'f',2));

  wizPBStop->setEnabled(false);

#ifdef wzDEBUG
  debug("wizScan: init, minf %lu, maxf %lu, sigquality %d",minfreq,maxfreq,sigquality);
#endif
}


wizScan::~wizScan()
{
}

void wizScan::setScanInfo(QList<channel> * _list, int _norm, int _region, bool _all)
{ 
  scanstate = ScanSetup;

  list  = _list;
  norm   = _norm; 
  region = _region; 
  all    = _all; 
  
  lcountry.change(region);

  if ( all ) 
    frange = maxfreq - minfreq;
  else
    frange = lcountry.nftab();

#ifdef wzDEBUG
  debug("wizScan: norm %d, region %d, scan %s, range %d",norm,region,all?"ALL":"Region",frange);
#endif
    
  winTVScreenWidget::v4lxifP()->setChannel( 0 );
  winTVScreenWidget::v4lxifP()->setChannelNorm( norm );
  wizLCDFreq->display(QString().setNum(minfreq/16.0,'f',2));

  wizPBStart->setEnabled(true);
  wizPBStop->setEnabled(false);
  wizPBStart->setText(i18n("Start"));
  wizLLCFound->setText("0");
  wizPBProgress->reset();
}

void wizScan::wizPBStartSLOT()
{
  if ( scanstate == ScanContinue ) { 
#ifdef wzDEBUG
    debug("c2freq: wizPBStartSLOT - ScanContinue -> ScanInProgress");
#endif
    wizPBStart->setEnabled(false);
    wizPBStop->setEnabled(true);
    scanstate = ScanInProgress;

    if ( all ) {
      scanfval = 2;
      slost1 = true;
      sfound = false;
      slost2 = false;
      frequency = flost;
      ffound = frequency;
    } else {
      frequency=nfrequency;
    }
  }

  if ( scanstate == ScanAbort ) { 
#ifdef wzDEBUG
    debug("c2freq: wizPBStartSLOT - ScanAbort -> ScanContinueAfterAbort");
#endif
    scanstate = ScanContinueAfterAbort;
    wizPBStart->setEnabled(true);
    wizPBStop->setEnabled(false);
    wizPBStart->setText(i18n("Continue"));
  }

  if ( scanstate == ScanSetup ) {
    list->clear();
    wizPBProgress->reset();
    wizPBStart->setEnabled(false);
    wizPBStop->setEnabled(true);

    scanstate = ScanInProgress;

    ccount = 0;
    scanfval = 5;
    slost1 = (winTVScreenWidget::v4lxifP()->getTunerSignal() < sigquality);
    sfound = false;
    slost2 = false;
    if ( all ) {
      frequency = minfreq;
    } else { 
      frequency = lcountry.firstchan(cname);
      fstfrequency = frequency;
    }
    ffound = frequency;
    flost = frequency;
    winTVScreenWidget::v4lxifP()->setFreq(frequency);
  } 

  if ( scanstate == ScanInProgress ) {
    if ( all ) {
      frequency += scanfval;
      wizLCDFreq->display(QString().setNum(frequency/16.0,'f',2));
      wizPBProgress->setProgress((frequency-minfreq)*100/frange);
      if ( frequency > maxfreq ) {
	scanstate = ScanDone;
	wizPBStop->setEnabled(false);
	emit wizScanScanReadySIGNAL();
      } else {
	winTVScreenWidget::v4lxifP()->setFreq(frequency);
	QTimer::singleShot( SCAN_DELAY , this, SLOT(wizAutoScanSLOT()) );
      }
    } else {
      nfrequency = lcountry.nextchan(cname);
      wizPBProgress->setProgress(lcountry.activeindex()*100/frange);
      wizLCDFreq->display(QString().setNum(frequency/16.0,'f',2));
      if ( nfrequency == fstfrequency ) {
	scanstate = ScanDone;
	wizPBStop->setEnabled(false);
	emit wizScanScanReadySIGNAL();
      } else {
	winTVScreenWidget::v4lxifP()->setFreq(frequency);
	QTimer::singleShot( SCAN_DELAY * 4, this, SLOT(wizAutoScanSLOT()) );
	
      }
    }
    
    //qApp->processEvents( SCAN_DELAY );
  }

  if ( scanstate == ScanContinueAfterAbort ) { 
#ifdef wzDEBUG
  debug("c2freq: wizPBStartSLOT - ScanContinueAfterAbort -> ScanInProgress");
#endif
    scanstate = ScanContinue;
  }

}
void wizScan::wizPBStopSLOT()
{
#ifdef wzDEBUG
  debug("c2freq: wizPBStopSLOT - ScanAbort");
#endif

  scanstate = ScanAbort;
  emit wizScanScanReadySIGNAL();
}

void wizScan::wizAutoScanSLOT()
{
  if (scanstate == ScanAbort) {
    //scanstate = ScanContinue;
    //return;
    wizPBStartSLOT();
    return;
  }

  int quality = winTVScreenWidget::v4lxifP()->getTunerSignal();

#ifdef wzDEBUG
    debug("c2freq: autoScan %d, freq %d, done %d",quality,frequency,ccount*100/frange);
#endif

  if ( !all ) {

#ifdef wzDEBUG
    debug("c2freq: autoScan %d, chan %s, freq %d, cound %d, done %d",
	  quality,cname,frequency,ccount,ccount*100/frange);
#endif

    if ( quality >= sigquality ) {
      nchannel = new channel(frequency,
			     (const char *)QString("channel ").append(cname),
			     DCOL,DHUE,DBRI,DCONTRAST,
			     norm,
			     0, /* input = Tuner */
			     region,
			     "0" /* channel id */);

      wizLLCFound->setText(QString().setNum(++ccount));
      list->append(nchannel);
    }

    if (scanstate != ScanAbort) scanstate = ScanContinue;
    wizPBStartSLOT();

  } else {
    // scan all frequencies
    if ( !slost2 ) { 

      if ( !slost1 ) {
	slost1 = quality < sigquality;
	if ( slost1 ) scanfval = 2; // was 2
      } else if ( !sfound ) {
	sfound = quality > sigquality;
	if ( sfound ) { 
	  ffound = frequency;
	  smaxsig = quality;
	  fmaxsig = frequency;
	  scanfval = 1;
	  sfcount = 0;
	}
      } else if ( !slost2 ) {
	if ( smaxsig < quality ) {
	  smaxsig = quality;
	  fmaxsig = frequency;
	}
	sfcount++;
	slost2 = quality < sigquality;
	if ( slost2 ) {
	  flost = frequency - 1;
	  if ( sfcount < MIN_COUNT ) {
	    slost2=false;
	    sfound=false;
	  }
	}
      }

      wizPBStartSLOT();

    } else {
      //scanstate = ScanAbort;

#ifdef wzDEBUG
      debug("c2freq: autoScan %d, found at %d, lost at %d, set %d, delta %d",
	    quality,ffound,flost,(flost+ffound)/2,ffound-flost);
#endif

      if  ( slost1 && slost2 && sfound ) {
	if ( fmaxsig == ffound && smaxsig == 0xffff ) { // fake signal quality
	  frequency = 1 + (flost + ffound) / 2;
#ifdef wzDEBUG
	  debug("c2freq: fake sigquality mode, set %d",frequency);
#endif
	} else {
	  frequency = fmaxsig;
	}
	winTVScreenWidget::v4lxifP()->setFreq(frequency);
      }

      nchannel = new channel(frequency,
			     (const char *)(QString().setNum(frequency/16.0,'f',4)),
			     DCOL,DHUE,DBRI,DCONTRAST,
			     norm,
			     0, /* input = Tuner */
			     region,
			     cname /* channel id */);
      
      wizLLCFound->setText(QString().setNum(++ccount));
      list->append(nchannel);

      scanfval = 2;
      if (scanstate != ScanAbort) scanstate = ScanContinue;
      wizPBStartSLOT();

    }
  }
}
//-------------------------------------------------------------------
//-------------------------------------------------------------------
#include "wizScan.moc"






