#ifndef rootqevent_h
#define rootqevent_h

#include <qevent.h>

#define XRWEvent 1001

#if QT_VERSION < 200
class X11RWEvent : public QEvent               
{
public:
  X11RWEvent( int _id, int _xeventtyp , XEvent *_xevent)
    : QEvent(_id), id(_id), xenventtyp(_xeventtyp), xevent(_xevent) {}

  int   TheId()     const   { return id; }
  int   XEventTyp() const { return xenventtyp; }
  XEvent *XEventPtr()  const { return xevent; }

protected:
  int   id;
  int   xenventtyp;
  XEvent *xevent;
};
#else
class X11RWEvent : public QEvent               
{
public:
  X11RWEvent( int _type, int _xeventtyp , XEvent *_xevent)
    : QEvent((QEvent::Type)_type), type(_type), xenventtyp(_xeventtyp), xevent(_xevent) {}

  int   TheId()     const   { return type; }
  int   XEventTyp() const { return xenventtyp; }
  XEvent *XEventPtr()  const { return xevent; }

protected:
  int   type;
  int   xenventtyp;
  XEvent *xevent;
};
#endif

#define X11RWEvent_EVENT(x)        ((X11RWEvent*)x)

#endif // rootqevent_h
